Index: LMDZ6/branches/Amaury_dev/libf/dyn3d_common/infotrac.F90
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/dyn3d_common/infotrac.F90	(revision 5095)
+++ LMDZ6/branches/Amaury_dev/libf/dyn3d_common/infotrac.F90	(revision 5098)
@@ -3,277 +3,277 @@
 MODULE infotrac
 
-   USE       strings_mod, ONLY: msg, fmsg, maxlen, cat, dispTable, int2str, bool2str, strStack, strParse
-   USE readTracFiles_mod, ONLY: trac_type, readTracersFiles, tracers, setGeneration, itZonIso, nzone, tran0, isoZone, &
-        delPhase, niso, getKey, isot_type, processIsotopes,  isotope, maxTableWidth, iqIsoPha, nphas, ixIso, isoPhas, &
-        addPhase, iH2O, addKey, isoSelect, testTracersFiles, isoKeys, indexUpdate,  iqWIsoPha, nbIso, ntiso, isoName, isoCheck
-   IMPLICIT NONE
-
-   PRIVATE
-
-   !=== FOR TRACERS:
-   PUBLIC :: init_infotrac                                 !--- Initialization of the tracers
-   PUBLIC :: tracers, type_trac                            !--- Full tracers database, tracers type keyword
-   PUBLIC :: nqtot,   nbtr,   nqo,   nqCO2,   nqtottr      !--- Main dimensions
-   PUBLIC :: conv_flg, pbl_flg                             !--- Convection & boundary layer activation keys
-
-   !=== FOR ISOTOPES: General
-   PUBLIC :: isot_type, nbIso                              !--- Derived type, full isotopes families database + nb of families
-   PUBLIC :: isoSelect, ixIso                              !--- Isotopes family selection tool + selected family index
-   !=== FOR ISOTOPES: Specific to water
-   PUBLIC :: iH2O                                          !--- H2O isotopes class index
-   PUBLIC :: min_qParent, min_qMass, min_ratio             !--- Min. values for various isotopic quantities
-   !=== FOR ISOTOPES: Depending on the selected isotopes family
-   PUBLIC :: isotope, isoKeys                              !--- Selected isotopes database + associated keys (cf. getKey)
-   PUBLIC :: isoName, isoZone, isoPhas                     !--- Isotopes and tagging zones names, phases
-   PUBLIC :: niso,    nzone,   nphas,   ntiso              !---  " " numbers + isotopes & tagging tracers number
-   PUBLIC :: itZonIso                                      !--- idx "it" (in "isoName(1:niso)") = function(tagging idx, isotope idx)
-   PUBLIC :: iqIsoPha                                      !--- idx "iq" (in "qx") = function(isotope idx, phase idx) + aliases
-   PUBLIC :: isoCheck                                      !--- Run isotopes checking routines
-   !=== FOR BOTH TRACERS AND ISOTOPES
-   PUBLIC :: getKey                                        !--- Get a key from "tracers" or "isotope"
-
-!=== CONVENTIONS FOR TRACERS NUMBERS:
-!  |--------------------+-----------------------+-----------------+---------------+----------------------------|
-!  | water in different |    water tagging      |  water isotopes | other tracers | additional tracers moments |
-!  | phases: H2O_[gls]  |      isotopes         |                 |               |  for higher order schemes  |
-!  |--------------------+-----------------------+-----------------+---------------+----------------------------|
-!  |                    |                       |                 |               |                            |
-!  |<--     nqo      -->|<-- nqo*niso* nzone -->|<-- nqo*niso  -->|<--  nbtr   -->|<--        (nmom)        -->|         
-!  |                    |                                         |                                            |
-!  |                    |<-- nqo*niso*(nzone+1)  =   nqo*ntiso -->|<--    nqtottr = nbtr + nmom             -->|
-!  |                                                                              = nqtot - nqo*(ntiso+1)      |
-!  |                                                                                                           |
-!  |<--                        nqtrue  =  nbtr + nqo*(ntiso+1)                 -->|                            |
-!  |                                                                                                           |
-!  |<--                        nqtot   =  nqtrue + nmom                                                     -->|
-!  |                                                                                                           |
-!  |-----------------------------------------------------------------------------------------------------------|
-!  NOTES FOR THIS TABLE:
-!  * Used "niso", "nzone" and "ntiso" are components of "isotopes(ip)" for water (isotopes(ip)%parent == 'H2O'),
-!    since water is so far the sole tracers family, except passive CO2, removed from the main tracers table.
-!  * For water, "nqo" is equal to the more general field "isotopes(ip)%nphas".
-!  * "niso", "nzone", "ntiso", "nphas" are defined for other isotopic tracers families, if any.
-!
-!=== DERIVED TYPE EMBEDDING MOST OF THE TRACERS-RELATED QUANTITIES (LENGTH: nqtot)
-!    Each entry is accessible using "%" sign.
-!  |-------------+------------------------------------------------------+-------------+------------------------+
-!  |  entry      | Meaning                                              | Former name | Possible values        |
-!  |-------------+------------------------------------------------------+-------------+------------------------+
-!  | name        | Name (short)                                         | tname       |                        |
-!  | gen0Name    | Name of the 1st generation ancestor                  | /           |                        |
-!  | parent      | Name of the parent                                   | /           |                        |
-!  | longName    | Long name (with adv. scheme suffix) for outputs      | ttext       |                        |
-!  | type        | Type (so far: tracer or tag)                         | /           | tracer,tag             |
-!  | phase       | Phases list ("g"as / "l"iquid / "s"olid)             | /           | [g][l][s]              |
-!  | component   | Name(s) of the merged/cumulated section(s)           | /           | coma-separated names   |
-!  | iGeneration | Generation (>=1)                                     | /           |                        |
-!  | iqParent    | Index of the parent tracer                           | iqpere      | 1:nqtot                |
-!  | iqDescen    | Indexes of the childs       (all generations)        | iqfils      | 1:nqtot                |
-!  | nqDescen    | Number of the descendants   (all generations)        | nqdesc      | 1:nqtot                |
-!  | nqChildren  | Number of childs            (1st generation only)    | nqfils      | 1:nqtot                |
-!  | keys        | key/val pairs accessible with "getKey" routine       | /           |                        |
-!  | iadv        | Advection scheme number                              | iadv        | 1,2,10-20(exc.15,19),30|
-!  | isAdvected  | advected tracers flag (.TRUE. if iadv >= 0)          | /           | nqtrue  .TRUE. values  |
-!  | isInPhysics | tracers not extracted from the main table in physics | /           | nqtottr .TRUE. values  |
-!  | iso_iGroup  | Isotopes group index in isotopes(:)                  | /           | 1:nbIso                |
-!  | iso_iName   | Isotope  name  index in isotopes(iso_iGroup)%trac(:) | iso_indnum  | 1:niso                 |
-!  | iso_iZone   | Isotope  zone  index in isotopes(iso_iGroup)%zone(:) | zone_num    | 1:nzone                |
-!  | iso_iPhas   | Isotope  phase index in isotopes(iso_iGroup)%phas(:) | phase_num   | 1:nphas                |
-!  +-------------+------------------------------------------------------+-------------+------------------------+
-!
-!=== DERIVED TYPE EMBEDDING MOST OF THE ISOTOPES-RELATED QUANTITIES (LENGTH: nbIso, NUMBER OF ISOTOPES FAMILIES)
-!    Each entry is accessible using "%" sign.
-!  |-----------------+--------------------------------------------------+--------------------+-----------------+
-!  |  entry | length | Meaning                                          |    Former name     | Possible values |
-!  |-----------------+--------------------------------------------------+--------------------+-----------------+
-!  | parent          | Parent tracer (isotopes family name)             |                    |                 |
-!  | keys   | niso   | Isotopes keys/values pairs list + number         |                    |                 |
-!  | trac   | ntiso  | Isotopes + tagging tracers list + number         | / | ntraciso       |                 |
-!  | zone   | nzone  | Geographic tagging zones   list + number         | / | ntraceurs_zone |                 |
-!  | phase  | nphas  | Phases                     list + number         |                    | [g][l][s], 1:3  |
-!  | iqIsoPha        | Index in "qx"           = f(name(1:ntiso)),phas) | iqiso              | 1:nqtot         |
-!  | itZonIso        | Index in "trac(1:ntiso)"= f(zone, name(1:niso))  | index_trac         | 1:ntiso         |
-!  +-----------------+--------------------------------------------------+--------------------+-----------------+
-
-   REAL, PARAMETER :: min_qParent = 1.e-30, min_qMass = 1.e-18, min_ratio = 1.e-16 ! MVals et CRisi
-
-   !=== DIMENSIONS OF THE TRACERS TABLES AND OTHER SCALAR VARIABLES
-   INTEGER,               SAVE :: nqtot,  &                     !--- Tracers nb in dynamics (incl. higher moments + H2O)
-                                  nbtr,   &                     !--- Tracers nb in physics  (excl. higher moments + H2O)
-                                  nqo,    &                     !--- Number of water phases
-                                  nqtottr, &                    !--- Number of tracers passed to phytrac (TO BE DELETED ?)
-                                  nqCO2                         !--- Number of tracers of CO2  (ThL)
-   CHARACTER(LEN=maxlen), SAVE :: type_trac                     !--- Keyword for tracers type
-
-   !=== VARIABLES FOR INCA
-   INTEGER,               SAVE, ALLOCATABLE :: conv_flg(:), &   !--- Convection     activation ; needed for INCA        (nbtr)
-                                                pbl_flg(:)      !--- Boundary layer activation ; needed for INCA        (nbtr)
+  USE       strings_mod, ONLY : msg, fmsg, maxlen, cat, dispTable, int2str, bool2str, strStack, strParse
+  USE readTracFiles_mod, ONLY : trac_type, readTracersFiles, tracers, setGeneration, itZonIso, nzone, tran0, isoZone, &
+          delPhase, niso, getKey, isot_type, processIsotopes, isotope, maxTableWidth, iqIsoPha, nphas, ixIso, isoPhas, &
+          addPhase, iH2O, addKey, isoSelect, testTracersFiles, isoKeys, indexUpdate, iqWIsoPha, nbIso, ntiso, isoName, isoCheck
+  IMPLICIT NONE
+
+  PRIVATE
+
+  !=== FOR TRACERS:
+  PUBLIC :: init_infotrac                                 !--- Initialization of the tracers
+  PUBLIC :: tracers, type_trac                            !--- Full tracers database, tracers type keyword
+  PUBLIC :: nqtot, nbtr, nqo, nqCO2, nqtottr      !--- Main dimensions
+  PUBLIC :: conv_flg, pbl_flg                             !--- Convection & boundary layer activation keys
+
+  !=== FOR ISOTOPES: General
+  PUBLIC :: isot_type, nbIso                              !--- Derived type, full isotopes families database + nb of families
+  PUBLIC :: isoSelect, ixIso                              !--- Isotopes family selection tool + selected family index
+  !=== FOR ISOTOPES: Specific to water
+  PUBLIC :: iH2O                                          !--- H2O isotopes class index
+  PUBLIC :: min_qParent, min_qMass, min_ratio             !--- Min. values for various isotopic quantities
+  !=== FOR ISOTOPES: Depending on the selected isotopes family
+  PUBLIC :: isotope, isoKeys                              !--- Selected isotopes database + associated keys (cf. getKey)
+  PUBLIC :: isoName, isoZone, isoPhas                     !--- Isotopes and tagging zones names, phases
+  PUBLIC :: niso, nzone, nphas, ntiso              !---  " " numbers + isotopes & tagging tracers number
+  PUBLIC :: itZonIso                                      !--- idx "it" (in "isoName(1:niso)") = function(tagging idx, isotope idx)
+  PUBLIC :: iqIsoPha                                      !--- idx "iq" (in "qx") = function(isotope idx, phase idx) + aliases
+  PUBLIC :: isoCheck                                      !--- Run isotopes checking routines
+  !=== FOR BOTH TRACERS AND ISOTOPES
+  PUBLIC :: getKey                                        !--- Get a key from "tracers" or "isotope"
+
+  !=== CONVENTIONS FOR TRACERS NUMBERS:
+  !  |--------------------+-----------------------+-----------------+---------------+----------------------------|
+  !  | water in different |    water tagging      |  water isotopes | other tracers | additional tracers moments |
+  !  | phases: H2O_[gls]  |      isotopes         |                 |               |  for higher order schemes  |
+  !  |--------------------+-----------------------+-----------------+---------------+----------------------------|
+  !  |                    |                       |                 |               |                            |
+  !  |<--     nqo      -->|<-- nqo*niso* nzone -->|<-- nqo*niso  -->|<--  nbtr   -->|<--        (nmom)        -->|
+  !  |                    |                                         |                                            |
+  !  |                    |<-- nqo*niso*(nzone+1)  =   nqo*ntiso -->|<--    nqtottr = nbtr + nmom             -->|
+  !  |                                                                              = nqtot - nqo*(ntiso+1)      |
+  !  |                                                                                                           |
+  !  |<--                        nqtrue  =  nbtr + nqo*(ntiso+1)                 -->|                            |
+  !  |                                                                                                           |
+  !  |<--                        nqtot   =  nqtrue + nmom                                                     -->|
+  !  |                                                                                                           |
+  !  |-----------------------------------------------------------------------------------------------------------|
+  !  NOTES FOR THIS TABLE:
+  !  * Used "niso", "nzone" and "ntiso" are components of "isotopes(ip)" for water (isotopes(ip)%parent == 'H2O'),
+  !    since water is so far the sole tracers family, except passive CO2, removed from the main tracers table.
+  !  * For water, "nqo" is equal to the more general field "isotopes(ip)%nphas".
+  !  * "niso", "nzone", "ntiso", "nphas" are defined for other isotopic tracers families, if any.
+  !
+  !=== DERIVED TYPE EMBEDDING MOST OF THE TRACERS-RELATED QUANTITIES (LENGTH: nqtot)
+  !    Each entry is accessible using "%" sign.
+  !  |-------------+------------------------------------------------------+-------------+------------------------+
+  !  |  entry      | Meaning                                              | Former name | Possible values        |
+  !  |-------------+------------------------------------------------------+-------------+------------------------+
+  !  | name        | Name (short)                                         | tname       |                        |
+  !  | gen0Name    | Name of the 1st generation ancestor                  | /           |                        |
+  !  | parent      | Name of the parent                                   | /           |                        |
+  !  | longName    | Long name (with adv. scheme suffix) for outputs      | ttext       |                        |
+  !  | type        | Type (so far: tracer or tag)                         | /           | tracer,tag             |
+  !  | phase       | Phases list ("g"as / "l"iquid / "s"olid)             | /           | [g][l][s]              |
+  !  | component   | Name(s) of the merged/cumulated section(s)           | /           | coma-separated names   |
+  !  | iGeneration | Generation (>=1)                                     | /           |                        |
+  !  | iqParent    | Index of the parent tracer                           | iqpere      | 1:nqtot                |
+  !  | iqDescen    | Indexes of the childs       (all generations)        | iqfils      | 1:nqtot                |
+  !  | nqDescen    | Number of the descendants   (all generations)        | nqdesc      | 1:nqtot                |
+  !  | nqChildren  | Number of childs            (1st generation only)    | nqfils      | 1:nqtot                |
+  !  | keys        | key/val pairs accessible with "getKey" routine       | /           |                        |
+  !  | iadv        | Advection scheme number                              | iadv        | 1,2,10-20(exc.15,19),30|
+  !  | isAdvected  | advected tracers flag (.TRUE. if iadv >= 0)          | /           | nqtrue  .TRUE. values  |
+  !  | isInPhysics | tracers not extracted from the main table in physics | /           | nqtottr .TRUE. values  |
+  !  | iso_iGroup  | Isotopes group index in isotopes(:)                  | /           | 1:nbIso                |
+  !  | iso_iName   | Isotope  name  index in isotopes(iso_iGroup)%trac(:) | iso_indnum  | 1:niso                 |
+  !  | iso_iZone   | Isotope  zone  index in isotopes(iso_iGroup)%zone(:) | zone_num    | 1:nzone                |
+  !  | iso_iPhas   | Isotope  phase index in isotopes(iso_iGroup)%phas(:) | phase_num   | 1:nphas                |
+  !  +-------------+------------------------------------------------------+-------------+------------------------+
+  !
+  !=== DERIVED TYPE EMBEDDING MOST OF THE ISOTOPES-RELATED QUANTITIES (LENGTH: nbIso, NUMBER OF ISOTOPES FAMILIES)
+  !    Each entry is accessible using "%" sign.
+  !  |-----------------+--------------------------------------------------+--------------------+-----------------+
+  !  |  entry | length | Meaning                                          |    Former name     | Possible values |
+  !  |-----------------+--------------------------------------------------+--------------------+-----------------+
+  !  | parent          | Parent tracer (isotopes family name)             |                    |                 |
+  !  | keys   | niso   | Isotopes keys/values pairs list + number         |                    |                 |
+  !  | trac   | ntiso  | Isotopes + tagging tracers list + number         | / | ntraciso       |                 |
+  !  | zone   | nzone  | Geographic tagging zones   list + number         | / | ntraceurs_zone |                 |
+  !  | phase  | nphas  | Phases                     list + number         |                    | [g][l][s], 1:3  |
+  !  | iqIsoPha        | Index in "qx"           = f(name(1:ntiso)),phas) | iqiso              | 1:nqtot         |
+  !  | itZonIso        | Index in "trac(1:ntiso)"= f(zone, name(1:niso))  | index_trac         | 1:ntiso         |
+  !  +-----------------+--------------------------------------------------+--------------------+-----------------+
+
+  REAL, PARAMETER :: min_qParent = 1.e-30, min_qMass = 1.e-18, min_ratio = 1.e-16 ! MVals et CRisi
+
+  !=== DIMENSIONS OF THE TRACERS TABLES AND OTHER SCALAR VARIABLES
+  INTEGER, SAVE :: nqtot, &                     !--- Tracers nb in dynamics (incl. higher moments + H2O)
+          nbtr, &                     !--- Tracers nb in physics  (excl. higher moments + H2O)
+          nqo, &                     !--- Number of water phases
+          nqtottr, &                    !--- Number of tracers passed to phytrac (TO BE DELETED ?)
+          nqCO2                         !--- Number of tracers of CO2  (ThL)
+  CHARACTER(LEN = maxlen), SAVE :: type_trac                     !--- Keyword for tracers type
+
+  !=== VARIABLES FOR INCA
+  INTEGER, SAVE, ALLOCATABLE :: conv_flg(:), &   !--- Convection     activation ; needed for INCA        (nbtr)
+          pbl_flg(:)      !--- Boundary layer activation ; needed for INCA        (nbtr)
 
 CONTAINS
 
-SUBROUTINE init_infotrac
-   USE control_mod, ONLY: planet_type
+  SUBROUTINE init_infotrac
+    USE control_mod, ONLY : planet_type
 #ifdef REPROBUS
    USE CHEM_REP,    ONLY: Init_chem_rep_trac
 #endif
-   USE lmdz_cppkeys_wrapper, ONLY: CPPKEY_INCA
-   IMPLICIT NONE
-!==============================================================================================================================
-!
-!   Auteur:  P. Le Van /L. Fairhead/F.Hourdin
-!   -------
-!
-!   Modifications:
-!   --------------
-!   05/94: F.Forget      Modif special traceur
-!   02/02: M-A Filiberti Lecture de traceur.def
-!   01/22: D. Cugnet     Nouveaux tracer.def et tracer_*.def + encapsulation (types trac_type et isot_type)
-!
-!   Objet:
-!   ------
-!   GCM LMD nouvelle grille
-!
-!==============================================================================================================================
-!   ... modification de l'integration de q ( 26/04/94 ) ....
-!------------------------------------------------------------------------------------------------------------------------------
-! Declarations:
-   INCLUDE "dimensions.h"
-   INCLUDE "iniprint.h"
-
-!------------------------------------------------------------------------------------------------------------------------------
-! Local variables
-   INTEGER, ALLOCATABLE :: hadv(:), vadv(:)                          !--- Horizontal/vertical transport scheme number
-   INTEGER, ALLOCATABLE :: had (:), hadv_inca(:), conv_flg_inca(:), &!--- Variables specific to INCA
-                           vad (:), vadv_inca(:),  pbl_flg_inca(:)
-   CHARACTER(LEN=8), ALLOCATABLE :: solsym_inca(:)                   !--- Tracers names for INCA
-   INTEGER :: nqINCA
-   CHARACTER(LEN=2)      ::   suff(9)                                !--- Suffixes for schemes of order 3 or 4 (Prather)
-   CHARACTER(LEN=3)      :: descrq(30)                               !--- Advection scheme description tags
-   CHARACTER(LEN=maxlen) :: msg1, texp, ttp                          !--- Strings for messages and expanded tracers type
-   INTEGER :: fType                                                  !--- Tracers description file type ; 0: none
-                                                                     !--- 1/2/3: "traceur.def"/"tracer.def"/"tracer_*.def"
-   INTEGER :: nqtrue                                                 !--- Tracers nb from tracer.def (no higher order moments)
-   INTEGER :: iad                                                    !--- Advection scheme number
-   INTEGER :: iq, jq, nt, im, nm                                     !--- Indexes and temporary variables
-   LOGICAL :: lerr, ll
-   TYPE(trac_type), ALLOCATABLE, TARGET :: ttr(:)
-   TYPE(trac_type), POINTER             :: t1, t(:)
-   CHARACTER(LEN=maxlen),   ALLOCATABLE :: types_trac(:)  !--- Keyword for tracers type(s), parsed version
-
-   CHARACTER(LEN=*), PARAMETER :: modname="init_infotrac"
-!------------------------------------------------------------------------------------------------------------------------------
-! Initialization :
-!------------------------------------------------------------------------------------------------------------------------------
-   suff          = ['x ','y ','z ','xx','xy','xz','yy','yz','zz']
-   descrq( 1:30) =  '   '
-   descrq( 1: 2) = ['LMV','BAK']
-   descrq(10:20) = ['VL1','VLP','FH1','FH2','VLH','   ','PPM','PPS','PPP','   ','SLP']
-   descrq(30)    =  'PRA'
-    
-   CALL msg('type_trac = "'//TRIM(type_trac)//'"', modname)
-
-   lerr=strParse(type_trac, '|', types_trac, n=nt)
-   IF (nt > 1) THEN
+    USE lmdz_cppkeys_wrapper, ONLY : CPPKEY_INCA, CPPKEY_STRATAER
+    IMPLICIT NONE
+    !==============================================================================================================================
+    !
+    !   Auteur:  P. Le Van /L. Fairhead/F.Hourdin
+    !   -------
+    !
+    !   Modifications:
+    !   --------------
+    !   05/94: F.Forget      Modif special traceur
+    !   02/02: M-A Filiberti Lecture de traceur.def
+    !   01/22: D. Cugnet     Nouveaux tracer.def et tracer_*.def + encapsulation (types trac_type et isot_type)
+    !
+    !   Objet:
+    !   ------
+    !   GCM LMD nouvelle grille
+    !
+    !==============================================================================================================================
+    !   ... modification de l'integration de q ( 26/04/94 ) ....
+    !------------------------------------------------------------------------------------------------------------------------------
+    ! Declarations:
+    INCLUDE "dimensions.h"
+    INCLUDE "iniprint.h"
+
+    !------------------------------------------------------------------------------------------------------------------------------
+    ! Local variables
+    INTEGER, ALLOCATABLE :: hadv(:), vadv(:)                          !--- Horizontal/vertical transport scheme number
+    INTEGER, ALLOCATABLE :: had (:), hadv_inca(:), conv_flg_inca(:), &!--- Variables specific to INCA
+            vad (:), vadv_inca(:), pbl_flg_inca(:)
+    CHARACTER(LEN = 8), ALLOCATABLE :: solsym_inca(:)                   !--- Tracers names for INCA
+    INTEGER :: nqINCA
+    CHARACTER(LEN = 2) :: suff(9)                                !--- Suffixes for schemes of order 3 or 4 (Prather)
+    CHARACTER(LEN = 3) :: descrq(30)                               !--- Advection scheme description tags
+    CHARACTER(LEN = maxlen) :: msg1, texp, ttp                          !--- Strings for messages and expanded tracers type
+    INTEGER :: fType                                                  !--- Tracers description file type ; 0: none
+    !--- 1/2/3: "traceur.def"/"tracer.def"/"tracer_*.def"
+    INTEGER :: nqtrue                                                 !--- Tracers nb from tracer.def (no higher order moments)
+    INTEGER :: iad                                                    !--- Advection scheme number
+    INTEGER :: iq, jq, nt, im, nm                                     !--- Indexes and temporary variables
+    LOGICAL :: lerr, ll
+    TYPE(trac_type), ALLOCATABLE, TARGET :: ttr(:)
+    TYPE(trac_type), POINTER :: t1, t(:)
+    CHARACTER(LEN = maxlen), ALLOCATABLE :: types_trac(:)  !--- Keyword for tracers type(s), parsed version
+
+    CHARACTER(LEN = *), PARAMETER :: modname = "init_infotrac"
+    !------------------------------------------------------------------------------------------------------------------------------
+    ! Initialization :
+    !------------------------------------------------------------------------------------------------------------------------------
+    suff = ['x ', 'y ', 'z ', 'xx', 'xy', 'xz', 'yy', 'yz', 'zz']
+    descrq(1:30) = '   '
+    descrq(1:2) = ['LMV', 'BAK']
+    descrq(10:20) = ['VL1', 'VLP', 'FH1', 'FH2', 'VLH', '   ', 'PPM', 'PPS', 'PPP', '   ', 'SLP']
+    descrq(30) = 'PRA'
+
+    CALL msg('type_trac = "' // TRIM(type_trac) // '"', modname)
+
+    lerr = strParse(type_trac, '|', types_trac, n = nt)
+    IF (nt > 1) THEN
       IF (nt > 2) CALL abort_gcm(modname, 'you need to modify type_trac, this version is not supported by lmdz', 1)
-      if (nt == 2) type_trac=types_trac(2)
-   ENDIF
-
-
-   
-   !--- MESSAGE ABOUT THE CHOSEN CONFIGURATION
-   msg1 = 'For type_trac = "'//TRIM(type_trac)//'":'
-   SELECT CASE(type_trac)
-      CASE('inca'); CALL msg(TRIM(msg1)//' coupling with INCA chemistry model',        modname)
-      CASE('inco'); CALL msg(TRIM(msg1)//' coupling jointly with INCA and CO2 cycle',  modname)
-      CASE('repr'); CALL msg(TRIM(msg1)//' coupling with REPROBUS chemistry model',    modname)
-      CASE('co2i'); CALL msg(TRIM(msg1)//' you have chosen to run with CO2 cycle',     modname)
-      CASE('coag'); CALL msg(TRIM(msg1)//' tracers are treated for COAGULATION tests', modname)
-      CASE('lmdz'); CALL msg(TRIM(msg1)//' tracers are treated in LMDZ only',          modname)
-      CASE DEFAULT; CALL abort_gcm(modname,'type_trac='//TRIM(type_trac)//' not possible yet.',1)
-   END SELECT
-
-   !--- COHERENCE TEST BETWEEN "type_trac" AND PREPROCESSING KEYS
-   SELECT CASE(type_trac)
-      CASE('inca', 'inco')
+      if (nt == 2) type_trac = types_trac(2)
+    ENDIF
+
+
+
+    !--- MESSAGE ABOUT THE CHOSEN CONFIGURATION
+    msg1 = 'For type_trac = "' // TRIM(type_trac) // '":'
+    SELECT CASE(type_trac)
+    CASE('inca'); CALL msg(TRIM(msg1) // ' coupling with INCA chemistry model', modname)
+    CASE('inco'); CALL msg(TRIM(msg1) // ' coupling jointly with INCA and CO2 cycle', modname)
+    CASE('repr'); CALL msg(TRIM(msg1) // ' coupling with REPROBUS chemistry model', modname)
+    CASE('co2i'); CALL msg(TRIM(msg1) // ' you have chosen to run with CO2 cycle', modname)
+    CASE('coag'); CALL msg(TRIM(msg1) // ' tracers are treated for COAGULATION tests', modname)
+    CASE('lmdz'); CALL msg(TRIM(msg1) // ' tracers are treated in LMDZ only', modname)
+    CASE DEFAULT; CALL abort_gcm(modname, 'type_trac=' // TRIM(type_trac) // ' not possible yet.', 1)
+    END SELECT
+
+    !--- COHERENCE TEST BETWEEN "type_trac" AND PREPROCESSING KEYS
+    SELECT CASE(type_trac)
+    CASE('inca', 'inco')
       IF (CPPKEY_INCA) THEN
-         CALL abort_gcm(modname, 'You must add cpp key INCA and compile with INCA code', 1)
+        CALL abort_gcm(modname, 'You must add cpp key INCA and compile with INCA code', 1)
       END IF
-      CASE('repr')
+    CASE('repr')
 #ifndef REPROBUS
-         CALL abort_gcm(modname, 'You must add cpp key REPROBUS and compile with REPROBUS code', 1)
+      CALL abort_gcm(modname, 'You must add cpp key REPROBUS and compile with REPROBUS code', 1)
 #endif
-      CASE('coag')
-#ifndef CPP_StratAer
-         CALL abort_gcm(modname, 'You must add cpp key StratAer and compile with StratAer code', 1)
-#endif
-   END SELECT
-
-   nqCO2 = COUNT( [type_trac == 'inco', type_trac == 'co2i'] )
-
-!==============================================================================================================================
-! 1) Get the numbers of: true (first order only) tracers "nqtrue", water tracers "nqo" (vapor/liquid/solid)
-!==============================================================================================================================
-   texp = type_trac                                                  !=== EXPANDED VERSION OF "type_trac", WITH "|" SEPARATOR
-   IF(texp == 'inco') texp = 'co2i|inca'
-   IF(texp /= 'lmdz') texp = 'lmdz|'//TRIM(texp)
-
-   !=== DETERMINE THE TYPE OF THE INPUT TRACERS DESCRIPTION FILE
-   IF(testTracersFiles(modname, texp, fType, .TRUE.)) CALL abort_gcm(modname, 'problem with tracers file(s)',1)
-   ttp = type_trac; IF(fType /= 1) ttp = texp
-
-   IF(readTracersFiles(ttp, lRepr=type_trac=='repr')) CALL abort_gcm(modname, 'problem with tracers file(s)',1)
-   !---------------------------------------------------------------------------------------------------------------------------
-   IF(fType == 0) CALL abort_gcm(modname, 'Missing tracers file: "traceur.def", "tracer.def" or "tracer_<keyword>.def file.',1)
-   !---------------------------------------------------------------------------------------------------------------------------
-   IF(fType == 1 .AND. ANY(['inca','inco']==type_trac)) THEN         !=== FOUND OLD STYLE INCA "traceur.def"
-   !---------------------------------------------------------------------------------------------------------------------------
-   IF (CPPKEY_INCA) THEN
-      nqo = SIZE(tracers) - nqCO2
-      CALL Init_chem_inca_trac(nqINCA)                               !--- Get nqINCA from INCA
-      nbtr = nqINCA + nqCO2                                          !--- Number of tracers passed to phytrac
-      nqtrue = nbtr + nqo                                            !--- Total number of "true" tracers
-      IF(ALL([2,3] /= nqo)) CALL abort_gcm(modname, 'Only 2 or 3 water phases allowed ; found nqo='//TRIM(int2str(nqo)), 1)
-      ALLOCATE(hadv(nqtrue), hadv_inca(nqINCA), conv_flg_inca(nqINCA), solsym_inca(nqINCA))
-      ALLOCATE(vadv(nqtrue), vadv_inca(nqINCA),  pbl_flg_inca(nqINCA))
-      CALL init_transport(solsym_inca, conv_flg_inca, pbl_flg_inca, hadv_inca, vadv_inca)
-      ALLOCATE(ttr(nqtrue))
-      ttr(1:nqo+nqCO2)                  = tracers
-      ttr(1    :      nqo   )%component = 'lmdz'
-      ttr(1+nqo:nqCO2+nqo   )%component = 'co2i'
-      ttr(1+nqo+nqCO2:nqtrue)%component = 'inca'
-      ttr(1+nqo      :nqtrue)%name      = [('CO2     ', iq=1, nqCO2), solsym_inca]
-      ttr(1+nqo+nqCO2:nqtrue)%parent    = tran0
-      ttr(1+nqo+nqCO2:nqtrue)%phase     = 'g'
-      lerr = getKey('hadv', had, ky=tracers(:)%keys)
-      lerr = getKey('vadv', vad, ky=tracers(:)%keys)
-      hadv(1:nqo+nqCO2) = had(:); hadv(1+nqo+nqCO2:nqtrue) = hadv_inca
-      vadv(1:nqo+nqCO2) = vad(:); vadv(1+nqo+nqCO2:nqtrue) = vadv_inca
-      CALL MOVE_ALLOC(FROM=ttr, TO=tracers)
-      DO iq = 1, nqtrue
-         t1 => tracers(iq)
-         CALL addKey('name',      t1%name,      t1%keys)
-         CALL addKey('component', t1%component, t1%keys)
-         CALL addKey('parent',    t1%parent,    t1%keys)
-         CALL addKey('phase',     t1%phase,     t1%keys)
-      END DO
-      IF(setGeneration(tracers)) CALL abort_gcm(modname,'See above',1) !- SET FIELDS %iGeneration, %gen0Name
-      DEALLOCATE(had, hadv_inca, vad, vadv_inca, conv_flg_inca, pbl_flg_inca, solsym_inca)
-   END IF
-   !---------------------------------------------------------------------------------------------------------------------------
-   ELSE                                                              !=== OTHER CASES (OLD OR NEW FORMAT, NO INCA MODULE)
-   !---------------------------------------------------------------------------------------------------------------------------
-      nqo    =        COUNT(delPhase(tracers(:)%name)     == 'H2O' &
-                               .AND. tracers(:)%component == 'lmdz') !--- Number of water phases
+    CASE('coag')
+      IF (.NOT. CPPKEY_STRATAER) THEN
+        CALL abort_gcm(modname, 'You must add cpp key StratAer and compile with StratAer code', 1)
+      END IF
+    END SELECT
+
+    nqCO2 = COUNT([type_trac == 'inco', type_trac == 'co2i'])
+
+    !==============================================================================================================================
+    ! 1) Get the numbers of: true (first order only) tracers "nqtrue", water tracers "nqo" (vapor/liquid/solid)
+    !==============================================================================================================================
+    texp = type_trac                                                  !=== EXPANDED VERSION OF "type_trac", WITH "|" SEPARATOR
+    IF(texp == 'inco') texp = 'co2i|inca'
+    IF(texp /= 'lmdz') texp = 'lmdz|' // TRIM(texp)
+
+    !=== DETERMINE THE TYPE OF THE INPUT TRACERS DESCRIPTION FILE
+    IF(testTracersFiles(modname, texp, fType, .TRUE.)) CALL abort_gcm(modname, 'problem with tracers file(s)', 1)
+    ttp = type_trac; IF(fType /= 1) ttp = texp
+
+    IF(readTracersFiles(ttp, lRepr = type_trac=='repr')) CALL abort_gcm(modname, 'problem with tracers file(s)', 1)
+    !---------------------------------------------------------------------------------------------------------------------------
+    IF(fType == 0) CALL abort_gcm(modname, 'Missing tracers file: "traceur.def", "tracer.def" or "tracer_<keyword>.def file.', 1)
+    !---------------------------------------------------------------------------------------------------------------------------
+    IF(fType == 1 .AND. ANY(['inca', 'inco']==type_trac)) THEN         !=== FOUND OLD STYLE INCA "traceur.def"
+      !---------------------------------------------------------------------------------------------------------------------------
+      IF (CPPKEY_INCA) THEN
+        nqo = SIZE(tracers) - nqCO2
+        CALL Init_chem_inca_trac(nqINCA)                               !--- Get nqINCA from INCA
+        nbtr = nqINCA + nqCO2                                          !--- Number of tracers passed to phytrac
+        nqtrue = nbtr + nqo                                            !--- Total number of "true" tracers
+        IF(ALL([2, 3] /= nqo)) CALL abort_gcm(modname, 'Only 2 or 3 water phases allowed ; found nqo=' // TRIM(int2str(nqo)), 1)
+        ALLOCATE(hadv(nqtrue), hadv_inca(nqINCA), conv_flg_inca(nqINCA), solsym_inca(nqINCA))
+        ALLOCATE(vadv(nqtrue), vadv_inca(nqINCA), pbl_flg_inca(nqINCA))
+        CALL init_transport(solsym_inca, conv_flg_inca, pbl_flg_inca, hadv_inca, vadv_inca)
+        ALLOCATE(ttr(nqtrue))
+        ttr(1:nqo + nqCO2) = tracers
+        ttr(1:nqo)%component = 'lmdz'
+        ttr(1 + nqo:nqCO2 + nqo)%component = 'co2i'
+        ttr(1 + nqo + nqCO2:nqtrue)%component = 'inca'
+        ttr(1 + nqo:nqtrue)%name = [('CO2     ', iq = 1, nqCO2), solsym_inca]
+        ttr(1 + nqo + nqCO2:nqtrue)%parent = tran0
+        ttr(1 + nqo + nqCO2:nqtrue)%phase = 'g'
+        lerr = getKey('hadv', had, ky = tracers(:)%keys)
+        lerr = getKey('vadv', vad, ky = tracers(:)%keys)
+        hadv(1:nqo + nqCO2) = had(:); hadv(1 + nqo + nqCO2:nqtrue) = hadv_inca
+        vadv(1:nqo + nqCO2) = vad(:); vadv(1 + nqo + nqCO2:nqtrue) = vadv_inca
+        CALL MOVE_ALLOC(FROM = ttr, TO = tracers)
+        DO iq = 1, nqtrue
+          t1 => tracers(iq)
+          CALL addKey('name', t1%name, t1%keys)
+          CALL addKey('component', t1%component, t1%keys)
+          CALL addKey('parent', t1%parent, t1%keys)
+          CALL addKey('phase', t1%phase, t1%keys)
+        END DO
+        IF(setGeneration(tracers)) CALL abort_gcm(modname, 'See above', 1) !- SET FIELDS %iGeneration, %gen0Name
+        DEALLOCATE(had, hadv_inca, vad, vadv_inca, conv_flg_inca, pbl_flg_inca, solsym_inca)
+      END IF
+      !---------------------------------------------------------------------------------------------------------------------------
+    ELSE                                                              !=== OTHER CASES (OLD OR NEW FORMAT, NO INCA MODULE)
+      !---------------------------------------------------------------------------------------------------------------------------
+      nqo = COUNT(delPhase(tracers(:)%name)     == 'H2O' &
+              .AND. tracers(:)%component == 'lmdz') !--- Number of water phases
       nqtrue = SIZE(tracers)                                         !--- Total number of "true" tracers
-      nbtr   = nqtrue-COUNT(delPhase(tracers(:)%gen0Name) == 'H2O' &
-                               .AND. tracers(:)%component == 'lmdz') !--- Number of tracers passed to phytrac
-   IF (CPPKEY_INCA) THEN
-      nqINCA = COUNT(tracers(:)%component == 'inca')
-   END IF
-      lerr = getKey('hadv', hadv, ky=tracers(:)%keys)
-      lerr = getKey('vadv', vadv, ky=tracers(:)%keys)
-   !---------------------------------------------------------------------------------------------------------------------------
-   END IF
-   !---------------------------------------------------------------------------------------------------------------------------
+      nbtr = nqtrue - COUNT(delPhase(tracers(:)%gen0Name) == 'H2O' &
+              .AND. tracers(:)%component == 'lmdz') !--- Number of tracers passed to phytrac
+      IF (CPPKEY_INCA) THEN
+        nqINCA = COUNT(tracers(:)%component == 'inca')
+      END IF
+      lerr = getKey('hadv', hadv, ky = tracers(:)%keys)
+      lerr = getKey('vadv', vadv, ky = tracers(:)%keys)
+      !---------------------------------------------------------------------------------------------------------------------------
+    END IF
+    !---------------------------------------------------------------------------------------------------------------------------
 
 #ifdef REPROBUS
